/*****************************************************************************/
/* Copyright 2006 Ikanos Communication                                       */
/*                                                                           */
/* "Ikanos USB ADSL2 Driver for Linux" is distributed in the hope that it    */
/* will be useful, but WITHOUT ANY WARRANTY; without even the implied        */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with "Ikanos USB ADSL2 Driver for Linux"; if not, write to the Free */
/* Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,            */
/* MA  02111-1307  USA                                                       */
/*                                                                           */
/* Written by Farinam Farahmand (farinam@gmail.com                           */
/*                                                                           */
/*****************************************************************************/



#ifdef E4USER
#include <netinet/in.h>
#else
#include "Adiutil.h"
#include "macros.h"

/*include "eu_utils.h"*/
#include "debug.h"
#endif
#include "e4_mp.h"

/*
unsigned short e4_mp_msg_encode 
(
	unsigned char ucRWFlag,
	uint16_t usGroup,
	uint16_t usAddress,
	uint16_t usIndex,
	uint32_t uiData,
	uint16_t usPayloadSize,
	uint16_t *mp_raw 
);


unsigned short e4_mp_msg_decode (e4_cmv_msg_t * msg, uint16_t *mp_raw );
*/
uint16_t e4_mp_msg_encode 
(
	unsigned char ucRWFlag,
	uint16_t usGroup,
	uint16_t usAddress,
	uint16_t usIndex,
	uint32_t uiData,
	uint16_t usPayloadSize,
	uint16_t *mp_raw 
) 
{
	int i = 0;
	e4_cmv_msg_t cmvCommand;
	uint16_t *usPtr = (uint16_t *) &cmvCommand;
	uint32_t *ulDes = (uint32_t *) &cmvCommand;

	if ( (usGroup < 1) || (usGroup > EAGLEIV_MAX_NUM_CMVGROUP) )
		return MP_ENCODE_ERROR;

	for ( i = 0; i<EAGLEIV_MP_BUFFER_SIZE; i++ )
		usPtr[i] = 0;
	
	if ( (usPayloadSize < 1) || (usPayloadSize > 4) )  
		return MP_ENCODE_ERROR;

	if ( (ucRWFlag == 'R') || (ucRWFlag == 'r') )
		cmvCommand.function = (uint16_t) (H2D_CMV_READ << 4 );
	else if ( (ucRWFlag == 'W') || (ucRWFlag == 'w') )
	{
		if ( usPayloadSize > 2 )
			return MP_ENCODE_ERROR;

		cmvCommand.function = (uint16_t) (H2D_CMV_WRITE << 4 );
		cmvCommand.payload.ushort[0] = (uint16_t) ( uiData & 0xFFFF );
		if ( usPayloadSize == 2 )
			cmvCommand.payload.ushort[1] = (uint16_t) ( (uiData >> 16) & 0xFFFF );
	}
	else
		return MP_ENCODE_ERROR; /* if rw flag is incorrect.*/

	cmvCommand.function |= usPayloadSize;
	cmvCommand.address = usAddress;
	cmvCommand.index = usIndex;
	cmvCommand.group = usGroup;


	/* ad6505 */
	for(i=0; i<EAGLEIV_MP_BUFFER_SIZE/2; i++)
		ulDes[i] = ntohl(ulDes[i]);
	
	for(i=0;i<EAGLEIV_MP_BUFFER_SIZE;i++)
		mp_raw[i] = usPtr[i];

	return MP_ENCODE_OK;
}




unsigned short e4_mp_msg_decode (e4_cmv_msg_t * msg, uint16_t *mp_raw ) 
{
	int i;
	uint32_t  *ulSrc;
	uint32_t  *ulDes;

	ulDes = (uint32_t *)msg;
	ulSrc = (uint32_t *)mp_raw;
	for(i=0; i<EAGLEIV_MP_BUFFER_SIZE/2; i++)
		ulDes[i] = ntohl(ulSrc[i]);
	

	return MP_ENCODE_OK;
}


