/*****************************************************************************/
/* Copyright 2006 Ikanos Communication                                       */
/*                                                                           */
/* "Ikanos USB ADSL2 Driver for Linux" is distributed in the hope that it    */
/* will be useful, but WITHOUT ANY WARRANTY; without even the implied        */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with "Ikanos USB ADSL2 Driver for Linux"; if not, write to the Free */
/* Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,            */
/* MA  02111-1307  USA                                                       */
/*                                                                           */
/* Written by Farinam Farahmand (farinam@gmail.com )                         */
/*                                                                           */
/*****************************************************************************/

#ifndef E4_MP_H
#define E4_MP_H

#ifndef true 
#define true 1
#endif
#ifndef false 
#define false 0
#endif
#ifndef ON 
#define ON 1
#endif
#ifndef OFF 
#define OFF 0
#endif


#define EAGLEIV_CMV_PAYLOAD_SIZE 12
#define EAGLEIV_MP_BUFFER_SIZE   16 /* 16 uint16_t or 32 bytes. */
#define EAGLEIV_MAX_NUM_CMVGROUP 8
#define MAX_NUM_OPERATIONAL_CMVS  20
#define MAX_NUM_RETRAIN_CMVS 22

#define MP_ENCODE_OK      0x00000000
#define MP_ENCODE_ERROR   0x00000001
#define MP_DECODE_OK      0x00000000
#define MP_DECODE_ERROR   0x00000001

#define H2D_CMV_WRITE 0x04
#define H2D_CMV_READ 0x0



enum EAGLEIV_CMD_GROUP 
{
    EAGLEIV_CMD_GROUP_START = 0,
    cmd_Group1, 
    cmd_Group2, 
    cmd_Group3, 
    cmd_Group4, 
    cmd_Group5, 
    cmd_Group6, 
    cmd_Group7, 
    cmd_Group8, 
    EAGLEIV_CMD_GROUP_END
};


typedef struct
{
    uint16_t function;
    uint16_t group;
    uint16_t address;
    uint16_t index;
    union
    {
        uint16_t ushort[EAGLEIV_CMV_PAYLOAD_SIZE];
        uint32_t ulong[EAGLEIV_CMV_PAYLOAD_SIZE/2];
    } payload;
} e4_cmv_msg_t;

/*typedef struct e4_cmv_msg_t e4_cmv_msg;*/

typedef enum {
    EIV_CMDTAG_CT, 
    EIV_CMDTAG_UR,
    EIV_CMDTAG_DR,
    EIV_CMDTAG_FV,
    EIV_CMDTAG_FD,  
    EIV_CMDTAG_AS,

    EIV_CMDTAG_CV1,
    EIV_CMDTAG_CV2,
    EIV_CMDTAG_CPV1,
    EIV_CMDTAG_CPV2,

    EIV_CMDTAG_NA,
    EIV_CMDTAG_FA,

    EIV_CMDTAG_LS,
    EIV_CMDTAG_NFLG,
    EIV_CMDTAG_NS,
    EIV_CMDTAG_FS,

    EIV_CMDTAG_NH,
    EIV_CMDTAG_NC,
    EIV_CMDTAG_FC,
    EIV_CMDTAG_NF,
    EIV_CMDTAG_FF,

    EIV_CMDTAG_DLT,
    EIV_CMDTAG_DMT,
    EIV_CMDTAG_DFE,
    EIV_CMDTAG_UFT,
    EIV_CMDTAG_UFE

} EIV_OPCMD_TAG;


typedef struct {

    uint16_t usMP[EAGLEIV_MP_BUFFER_SIZE];
    uint8_t ucPayloadSize;
    EIV_OPCMD_TAG cmvTag;
    uint32_t ulData[EAGLEIV_CMV_PAYLOAD_SIZE/2];
} EIV_OPERATIONAL_CMVS;


enum	_API_CONN_TYPE
{
   API_CONN_TYPE_INTERLEAVED,
   API_CONN_TYPE_FAST,
   API_CONN_TYPE_NOTDETECTED
};


uint16_t e4_mp_msg_encode 
(
	unsigned char ucRWFlag,
	uint16_t usGroup,
	uint16_t usAddress,
	uint16_t usIndex,
	uint32_t uiData,
	uint16_t usPayloadSize,
	uint16_t *mp_raw 
);

uint16_t e4_mp_msg_decode (e4_cmv_msg_t * msg, uint16_t *mp_raw );

#endif

